/*

*/
#include <windows.h>
#include <stdio.h>

int main() {
   HANDLE hProcess = GetCurrentProcess();
   DWORD processId = GetCurrentProcessId();
   DWORD processAffinityMask;
   DWORD  systemAffinityMask;


   while(1) {
      GetProcessAffinityMask(hProcess,
                             &processAffinityMask,
                             &systemAffinityMask);


      /* count the number of processors set in the affinity mask */
      int processorCount = 0;
      int mask = 1;
      for (int i = 1; i <= 32; i++) { /* limit the number of processors to 32 */
         if ( mask & processAffinityMask )
            processorCount++;
         mask <<= 1;
      }
      printf("processId = %d, processAffinityMask = %d, processorCount = %d\n",
              processId,      processAffinityMask,      processorCount);
      Sleep(1000);
   }
   return 0;
}
